Skip to main content

Templating

Overview​

You can customize many parts of the Eventcalendar by writing custom templates. In the context of plain javascript these templates are functions that return a string containing the html markup. You will find a comprehensive list of all the available render functions for the Eventcalendar in the API templates section.

Event templating​

When you want to customize how the events look, depending on what your goal is, you have two options:

  1. Customize the event content - Mobiscroll takes care of rendering the events in the correct order and also prints basic fields, like start/end, whether it is an allDay event or not and also takes care of coloring the event appropriately. Everything else comes from the custom template.
  2. Customize the full event - Mobiscroll takes care of rendering the events in the correct order, but everything else comes form the template you write.

To define a custom template, pass a functional to the apropriate option that returns the desired html:

Customizing the scheduler event contents
mobiscroll.eventcalendar('#myDiv', {
renderSchedulerEventContent: function (theEvent) {
return `<div>
${theEvent.title}
<!-- or any content you want -->
</div>`;
}
});

Event content templating​

In most cases you only want to customize the content section of the event. In this case your template will be used as the content of the event. Mobiscroll will position the event to the right place and will render essential information like the color of the event, the time and if it's an all day event or not. The title, description and any other fields you want to show (like participants, an avatar...) will be coming from your custom template.

mobiscroll.eventcalendar('#myDiv', {
renderAgendaEventContent: function (theEvent) {
// return your content here
},
});

Play with the slider below to see the differences.

Default template
Custom template

Full event templating​

In case of full event templating, whenever there is an event (in the agenda, scheduler, timeline, labels or popover) your custom template will be used instead of the default template. Mobiscroll will position your component to the right place, but anything else you want to show is up to you... like a title, description, color the background or show any content.

Play with the slider below to see the differences.

Default template
Custom template

Resource templating​

To customize the display of the resources, the renderResource option can be used.

mobiscroll.eventcalendar('#myDiv', {
renderResource: function (resource) {
return "<div>" + resource.name + " - " + resource.location + "</div>";
},
});
info

In case of the timeline view there are other parts of the Eventcalendar that can be customized through templates. Check out the timeline templating section for more details.

Play with the slider below to see the differences.

Default template
Custom template

Header templating​

The header of the calendar can be fully customized to one's needs with the use of the renderHeader option.

mobiscroll.eventcalendar('#myDiv', {
renderHeader: function () {
return "<p>Any <strong>Title</strong> you want here</p>";
},
});

While fully customizing the header is very usefull, sometimes it's desireable to customize only parts of it. In this case you can take advantage of the default header's building blocks. These components let you put toghether the header you want, while you don't have to worry about the functionality behind them.

For example you can leave out parts from the default header, change the order of the default buttons appearance or add custom components between them.

Here's the list of the built in components of the default header. You can initialize these by putting the attributes on the elements:

  • mbsc-calendar-prev - Previous button component, that navigates to the previous month.
  • mbsc-calendar-next - Next button component, that navigates to the next month.
  • mbsc-calendar-today - Today button component, that navigates to the current date.
  • mbsc-calendar-nav - The title navigation button component, that opens the year/month navigation.

The above components can be used inside of the custom header. The following example will render the prev and next buttons and then a custom title that is set from a custom variable (myTitle variable).

Custom header with default buttons
mobiscroll.eventcalendar('#myDiv', {
renderHeader: function () {
const myTitle = 'Awesome Title';
return `
<div mbsc-calendar-prev></div>
<div mbsc-calendar-next></div>
<div class="my-custom-title">${myTitle}</div>`;
},
});

Play with the slider below to see the differences.

Default template
Custom template

Skip to main content

Templating

Overview​

You can customize many parts of the Eventcalendar by writing custom templates. In Angular these templates are defined using the <ng-template> component and then passed to the eventcalendar as references. You will find a comprehensive list of all the templates available for the Eventcalendar in the API templates section.

Event templating​

When you want to customize how the events look, depending on what your goal is, you have two options:

  1. Customize the event content - Mobiscroll takes care of rendering the events in the correct order and also prints basic fields, like start/end, whether it is an allDay event or not and also takes care of coloring the event appropriately. Everything else comes from the custom template.
  2. Customize the full event - Mobiscroll takes care of rendering the events in the correct order, but everything else comes from the template you write.

To define a template, create an <ng-template> tag with a variable reference and pass it to the apropriate eventcalendar option:

Using the v-slot directive
<mbsc-eventcalendar [schedulerEventContentTemplate]="myTemplate">
<ng-template #myTemplate>
<!-- your content here -->
</ng-template>
</mbsc-eventcalendar>
import { Component } from '@angular/core';
import { MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'app-root',
templateUrl: './app.component.html',
standalone: true,
imports: [MbscModule],
})
export class AppComponent {}

Event content templating​

In most cases you only want to customize the content section of the event. In this case your template will be used as the content of the event. Mobiscroll will position the event to the right place and will render essential information like the color of the event, the time and if it's an all day event or not. The title, description and any other fields you want to show (like participants, an avatar...) will be coming from your custom template.

<mbsc-eventcalendar [agendaEventContentTemplate]="myAwesomeTemplate">
<ng-template #myAwesomeTemplate let-data>
<!-- your content here -->
</ng-template>
</mbsc-eventcalendar>
import { Component } from '@angular/core';
import { MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'app-root',
templateUrl: './app.component.html',
standalone: true,
imports: [MbscModule],
})
export class AppComponent {}

Play with the slider below to see the differences.

Default template
Custom template

Full event templating​

In case of full event templating, whenever there is an event (in the agenda, scheduler, timeline, labels or popover) your custom template will be used instead of the default template. Mobiscroll will position your component to the right place, but anything else you want to show is up to you... like a title, description, color the background or show any content.

Play with the slider below to see the differences.

Default template
Custom template

Resource templating​

To customize the display of the resources, the resourceTemplate can be used.

<mbsc-eventcalendar [resourceTemplate]="myResTemplate">
<ng-template #myResTemplate let-resource>
<div>{resource.name} - {resource.location}</div>
</ng-template>
</mbsc-eventcalendar>
import { Component } from '@angular/core';
import { MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'app-root',
templateUrl: './app.component.html',
standalone: true,
imports: [MbscModule],
})
export class AppComponent {}
info

In case of the timeline view there are other parts of the Eventcalendar that can be customized through templates. Check out the timeline templating section for more details.

Play with the slider below to see the differences.

Default template
Custom template

Header templating​

The header of the calendar can be fully customized to one's needs with the use of the headerTemplate option.

<mbsc-eventcalendar [headerTemplate]="header">
<ng-template #header>
<p>Any <strong>Title</strong> you want here or</p>
<your-custom-component [yourProp]="yourPropValue"></your-custom-component>
</ng-template>
</mbsc-eventcalendar>
import { Component } from '@angular/core';
import { MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'app-root',
templateUrl: './app.component.html',
standalone: true,
imports: [MbscModule],
})
export class AppComponent {}

While fully customizing the header is very usefull, sometimes it's desireable to customize only parts of it. In this case you can take advantage of the default header's building blocks. These components let you put toghether the header you want, while you don't have to worry about the functionality behind them.

For example you can leave out parts from the default header, change the order of the default buttons appearance or add custom components between them.

Here's the list of the built in components of the default header:

  • <mbsc-calendar-prev> - Previous button component, that navigates to the previous month.
  • <mbsc-calendar-next> - Next button component, that navigates to the next month.
  • <mbsc-calendar-today> - Today button component, that navigates to the current date.
  • <mbsc-calendar-nav> - The title navigation button component, that opens the year/month navigation.

The above components can be used inside of the custom header. The following example will render the prev and next buttons and then a custom title that is set from a custom variable (myTitle variable).

Custom header with default buttons
<mbsc-eventcalendar [headerTemplate]="header">
<ng-template #header>
<mbsc-calendar-prev></mbsc-calendar-prev>
<mbsc-calendar-next></mbsc-calendar-next>
<div class="my-custom-title">{{myTitle}}</div>
</ng-template>
</mbsc-eventcalendar>
import { Component } from '@angular/core';
import { MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'app-root',
templateUrl: './app.component.html',
standalone: true,
imports: [MbscModule],
})
export class AppComponent {}

Play with the slider below to see the differences.

Default template
Custom template